;================================================================
;
;  gas detector
;  version 1.0
;  
;  Microchip MPLAB IDE compiler   /www.microchip.com/
;
;================================================================

#include <P16F690.inc>

 __CONFIG _CPD_OFF & _CP_OFF & _BOR_OFF & _MCLRE_OFF & _PWRTE_OFF & _WDT_OFF & _INTRC_OSC_NOCLKOUT

rxlength  EQU .10
rxmaxbuf  EQU .11  
ADCGcnt   EQU .10
ADCGccnt  EQU ADCGcnt / 2


 cblock 0x120      
 endc

 cblock 0xA0        
  VADCGas: ADCGcnt
 endc

 cblock 0x20        
  rxbuf: rxmaxbuf
  COMTOUT
  CTMP0,DTMP1,DTMP2,DTMP3
  char1,chr1,char2,char3,chardot,dispchar1,dispchar2,dispchar3
  flags0,flags1,flags2,creg,dreg,ereg
  ctimer1
  ADCL, ADCH 
  PreHeat, GasCon, GasConDec, BattVolt, BattVoltDec
  disperr, SirenTmr, SirenOnMax, SirenOffMax
  TempVal,TempDec
  ADCBatHi, ADCBatLo, ADCGasHi, ADCGasLo, ADCTempHi, ADCTempLo
  VZeroGasHi, VZeroGasLo, VLoBattHi, VLoBattLo
  VZeroLM19Hi, VZeroLM19Lo, VBattDiv16, VDivLM19, VAutoCal
  VADCGasHi, VADCGasLo, VADCGidx,
  crcbit
 endc

                    
TMPW        EQU 0x7C
TMPS        EQU 0x7D
TMPFSR      EQU 0x7E
TMPPCLATH   EQU 0x7F

chr_minus   EQU .10
chr_blank   EQU .11
chr_allc    EQU .12
chr_2minc   EQU .13
chr_3minc   EQU .14
chr_HH      EQU .15 
chr_A       EQU .16
chr_C       EQU .17
chr_E       EQU .18
chr_F       EQU .19
chr_H       EQU .20
chr_I       EQU .21
chr_J       EQU .22
chr_L       EQU .23
chr_P       EQU .24
chr_S       EQU .25
chr_U       EQU .26
chr_G       EQU .44
chr_b       EQU .27
chr_c       EQU .28
chr_d       EQU .29
chr_h       EQU .30
chr_i       EQU .31
chr_n       EQU .32
chr_o       EQU .33
chr_r       EQU .34
chr_t       EQU .35
chr_u       EQU .36
chr_prce    EQU .37 
chr_gr      EQU .38 
chr_grad    EQU .39 
chr_lb      EQU .40 
chr_rb      EQU .41 
chr_db      EQU .42 
chr_ub      EQU .43 
lfchar      EQU .10
crchar      EQU .13

ctout       EQU .20  

fShowNone   EQU 0x0
fShowTemp   EQU 0x1
fShowHum    EQU 0x2
fShowGas1   EQU 0x3
fShowGas2   EQU 0x4
fShowBatt   EQU 0x5
fShowCal    EQU 0x6
fLoBatt     EQU 0x7

fBlinkDots  EQU 0x0
fButtonDwn  EQU 0x1
fShowButton EQU 0x2
fMeasureG1  EQU 0x3
fMeasureG2  EQU 0x4
fPreHeat    EQU 0x5
fError      EQU 0x6
fCRCError   EQU 0x7

fBatMeasure EQU 0x0
fBeepEnable EQU 0x1
fBeepPause  EQU 0x2
fMinusTemp  EQU 0x3
fMinusGas   EQU 0x4
fBeepHi     EQU 0x5
fBeepMid    EQU 0x6
fBeepLo     EQU 0x7

GasDet     EQU 0x0
LM19       EQU 0x1 
VBatt      EQU 0x2
Button     EQU 0x3    
Anode3     EQU 0x4     
SirenPin   EQU 0x5

Anode1     EQU 0x4
RXLine     EQU 0x5
Anode2     EQU 0x6
TXLine     EQU 0x7

CB12       EQU 0x0 
CG12       EQU 0x1          
CC12       EQU 0x2 
CDP12      EQU 0x3 
CD12       EQU 0x4          
CE12       EQU 0x5
CA12       EQU 0x6
CF12       EQU 0x7

#define button_Port PORTA
#define Siren_Port  PORTA

#define disable_bank_warn errorlevel -302
#define enable_bank_warn  errorlevel +302
#define disable_cpage_warn errorlevel -306
#define enable_cpage_warn  errorlevel +306

#define no_use_4MHz

#include picmacro.inc

cmprxb1 macro const1,jumpto
     movfw rxbuf+1
     sublw const1
     btfss STATUS,Z		
	 goto  jumpto
 endm

heater_wait_time EQU .10 
DivLM19          EQU .47
ZeroLM19Hi       EQU .2
ZeroLM19Lo       EQU .250
LoBattHi         EQU .1 
LoBattLo         EQU .167
BattDiv16        EQU .136
ZeroGasHi        EQU .0 
ZeroGasLo        EQU .24


#define ADCHiGasOffset 0
#define ADCLoGasOffset 1
#define Heater_time 2
#define ADCHiBattLow 3
#define ADCLoBattLow 4
#define ADCHiTemp0 5
#define ADCLoTemp0 6
#define DivisorLoBatt 7
#define DivisorLM19 8
#define OnPowerCal 9


     ORG     0x2100      
     de ZeroGasHi        
     de ZeroGasLo        
     de heater_wait_time 
     de LoBattHi         
     de LoBattLo         
     de ZeroLM19Hi       
     de ZeroLM19Lo       
     de BattDiv16        
     de DivLM19          
     de .0               
     de .100 
     de .110
     de .120 
     de .130
     de .140
     de .176 
     

     ORG     0x0
     goto    Start

     ORG     0x4     
Interrupt            
     movwf TMPW
     swapf STATUS,W
     clrf  STATUS    
     movwf TMPS
     movfw FSR
     movwf TMPFSR
     movfw PCLATH
     movwf TMPPCLATH
     clrf  PCLATH    

     btfsc PIR1,RCIF 
     goto  DoUsart 
     btfsc INTCON,RABIF 
     goto  DOPCInt
     btfsc INTCON,INTF  
     goto  DoINT0
     btfsc INTCON,T0IF  
     goto  DoTimer0
     btfsc PIR1,TMR1IF  
     goto  DoTimer1

IEEnd          
     movfw TMPPCLATH
     movwf PCLATH
     movfw TMPFSR
     movwf FSR
     swapf TMPS,W
     movwf STATUS
     swapf TMPW,F
     swapf TMPW,W
     retfie


DoUsart  
     movlf ctout,COMTOUT
     movlw rxlength
     subwf rxbuf,W
     btfsc STATUS,C  
     goto  DoUsartClrFIFO
     incf  rxbuf,F	
     movlw rxbuf	
     addwf rxbuf,W  
     movwf FSR      
     movff RCREG,INDF 
     btfss PIR1,RCIF   
     goto  DoUsartEx
     incf  FSR,F
     movff RCREG,INDF
     incf  rxbuf,F		 
DoUsartEx                 
     goto  IEEnd
DoUsartClrFIFO
     movfw RCREG
     movfw RCREG
     goto  DoUsartEx

DoTimer0
     btfss flags2, fBeepEnable
     goto  DoTimer00c
     btfsc flags2, fBeepPause
     goto  DoTimer00c
     btfsc Siren_Port,SirenPin
     goto  DoTimer00c
     bsf   Siren_Port,SirenPin
     goto  DoTimer00
DoTimer00c
     bcf   Siren_Port,SirenPin   
DoTimer00
     call  UpdateDisplay
     bcf   INTCON,T0IF
     goto  IEEnd

DoTimer1  
     incfsz ctimer1,W 
     movwf  ctimer1
     movfw SirenTmr
     btfss STATUS,Z
     decf  SirenTmr,F  
     call  Beep
     movfw COMTOUT
     btfsc STATUS,Z
     goto  dtmr2
     decf  COMTOUT,F   
     goto  DoTimer1Ex
dtmr2
     movfw rxbuf       
     btfsc STATUS,Z		
	 goto  DoTimer1Ex  
     lwcall 'C',SendChar
     fwcall rxbuf,SendChar
     clrf  rxbuf
     bcf   RCSTA,CREN
     nop
     bsf   RCSTA,CREN	
DoTimer1Ex
     bcf   PIR1,TMR1IF  
     goto  IEEnd

DOPCInt
     bcf  INTCON,RABIF  
     goto IEEnd

DoINT0                    
     bcf   INTCON,INTF  
     goto  IEEnd


SendChar                
     bcf   STATUS,RP1   
     bcf   STATUS,RP0   
     btfss PIR1,TXIF    
     goto  $-1          
     movwf TXREG
     return

 disable_bank_warn

InitTimer0
     bsf   STATUS,RP0   
     bcf   OPTION_REG,T0CS
     bcf   OPTION_REG,PSA 
#ifdef use_4MHz
     bsf   OPTION_REG,PS0 
     bcf   OPTION_REG,PS1
     bcf   OPTION_REG,PS2 
#else
     bcf   OPTION_REG,PS0 
     bsf   OPTION_REG,PS1
     bcf   OPTION_REG,PS2 
#endif
     bcf   STATUS,RP0 
     bcf   INTCON,T0IF
     return


InitTimer1
     bcf   STATUS,RP0 
#ifdef use_4MHz
     movlf b'00000100',T1CON 
#else
     movlf b'00010100',T1CON 
#endif
     bsf   STATUS,RP0 
     bsf   PIE1,TMR1IE
     bcf   STATUS,RP0 
     bcf   PIR1,TMR1IF
     return


InitUSART
     bcf   STATUS,RP0   
     movlf b'10010000',RCSTA
     bsf   STATUS,RP0   
     movlf b'00100000',TXSTA 
     clrf  SPBRGH
#ifdef use_4MHz
     movlf .12,SPBRG   
     bsf   TXSTA,BRGH
     bcf   BAUDCTL,BRG16 
#else
     movlf .25,SPBRG  
     bcf   TXSTA,BRGH
     bsf   BAUDCTL,BRG16 
#endif
     bsf   PIE1,RCIE     
     bcf   STATUS,RP0    
     return
 
 
Start
     bsf   STATUS,RP0    
     movfw OSCCON
#ifdef use_4MHz
     iorlw b'01100000'   
#else
     iorlw b'01110000'   
#endif    
     movwf OSCCON      
     bcf   STATUS,RP0    
     bsf   STATUS,RP1    
     movlf b'00000000',CM1CON0
     movwf CM2CON0
     movlf b'00000111',ANSEL 
     clrf  ANSELH      
     bcf   STATUS,RP1  
     bsf   STATUS,RP0  
     movlf b'00100000',ADCON1 
     bcf   STATUS,RP0  
     movlf b'10000001',ADCON0
     bsf   STATUS,RP0  
     bcf   OPTION_REG,NOT_RABPU 
     movlf b'00001111',TRISA  
     movlf b'00100000',TRISB  
     movlf b'00000000',TRISC  
     bcf   STATUS,RP0    
     clrf  PORTC
     clrf  PORTA
     clrf  PORTB
     clrf  SirenTmr
     clrf  SirenOnMax
     clrf  SirenOffMax
     clrf  flags0
     clrf  flags1
     clrf  flags2
     clrf  chardot
     movlw chr_allc
     movwf char3
     movwf char2
     movwf char1
     call  InitTimer1
     call  InitTimer0
     call  InitUSART
     movlf b'11000000',INTCON  
     bsf   T1CON,TMR1ON 
     bsf   INTCON,T0IE  
     clrf  COMTOUT
     clrf  rxbuf
     bsf   STATUS,RP0 
     movlf b'00001101',WDTCON 
     bcf   STATUS,RP0     

 enable_bank_warn
     movlw .255
     movwf ctimer1
     bsf   flags1, fPreHeat
     bsf   flags1, fMeasureG1
     bsf   flags0, fShowGas1
     clrf  GasCon
     clrf  GasConDec
     clrf  BattVolt
     clrf  BattVoltDec
     clrf  TempVal
     clrf  TempDec
     call  ClearAvgGas
     call  BeepHi
     call  Delay1s
     call  BeepOFF
     movlw ADCHiGasOffset
     call  ReadEprom
     movwf VZeroGasHi
     movlw ADCLoGasOffset 
     call  ReadEprom
     movwf VZeroGasLo
     movlw Heater_time
     call  ReadEprom
     movwf PreHeat
     movlw ADCHiBattLow 
     call  ReadEprom
     movwf VLoBattHi
     movlw ADCLoBattLow 
     call  ReadEprom
     movwf VLoBattLo
     movlw ADCHiTemp0 
     call  ReadEprom
     movwf VZeroLM19Hi
     movlw ADCLoTemp0 
     call  ReadEprom
     movwf VZeroLM19Lo
     movlw DivisorLoBatt
     call  ReadEprom
     movwf VBattDiv16
     movlw DivisorLM19
     call  ReadEprom
     movwf VDivLM19
     movlw OnPowerCal
     call  ReadEprom
     movwf VAutoCal
 disable_cpage_warn
     pagesel CalcEpromCRC
     call  CalcEpromCRC
     pagesel Loop
 enable_cpage_warn
     btfss flags1,fCRCError  
     goto  Loop
     movlw chr_r
     movwf char2
     movlw chr_C
     movwf char1
     movwf char3
     movlw heater_wait_time 
     movwf PreHeat
     movlw ZeroLM19Hi 
     movwf VZeroLM19Hi
     movlw ZeroLM19Lo
     movwf VZeroLM19Lo
     movlw LoBattHi
     movwf VLoBattHi
     movlw LoBattLo
     movwf VLoBattLo
     movlw ZeroGasHi
     movwf VZeroGasHi
     movlw ZeroGasLo
     movwf VZeroGasLo
     movlw BattDiv16
     movwf VBattDiv16
     movlw DivLM19
     movwf VDivLM19
     clrf  VAutoCal

Loop
     clrwdt
     call  IsMeasureTime
     call  CheckUSART
     call  CheckBattTemp
     btfsc flags1, fPreHeat
     goto  DoPreHeat
     call  CheckGas
     btfsc flags0, fShowCal
     call  DoCal
     movfw VAutoCal
     btfss STATUS,Z
     bsf   flags0, fShowCal
     clrf  VAutoCal
     btfsc flags0, fLoBatt
     goto  Loop
     btfsc flags1,fCRCError
     goto  Loop
LoopButton
     call  CheckButtonDown
     btfsc flags1, fButtonDwn
     call  ShowButtonDown
     btfss button_Port,Button
     goto  LoopButton
     btfsc flags0, fShowGas1
     call  SetGas1
     btfsc flags0, fShowGas2
     call  SetGas2
     call  ShowMeasure
     goto  Loop
DoPreHeat
     call  ShowHeat
     goto  Loop


SetGas1
     bsf   flags0, fShowGas1
     bcf   flags0, fShowGas2
     bsf   flags1, fMeasureG1
     bcf   flags1, fMeasureG2
     return

SetGas2
     bcf   flags0, fShowGas1
     bsf   flags0, fShowGas2
     bcf   flags1, fMeasureG1
     bsf   flags1, fMeasureG2
     return

DoCal
     movlw  chr_lb
     movwf  char1
     movlw  chr_2minc
     movwf  char2
     movlw  chr_rb
     movwf  char3
     call  Delay1s
     movlw .0    
     call ReadADC
     movfw ADCL
     movwf VZeroGasLo
     movfw ADCH
     movwf VZeroGasHi  
     bcf   flags0, fShowCal
     btfsc flags1, fMeasureG1
     call  SetGas1
     btfsc flags1, fMeasureG2
     call  SetGas2
     return

IsMeasureTime
     movfw ctimer1
     sublw .15
     btfss STATUS,Z
     goto  IsMeasureTime1
     bsf   flags2, fBatMeasure
     incf  ctimer1,F
IsMeasureTime1
     movfw ctimer1
     sublw .30   
     btfsc STATUS,C 
     return
     clrf  ctimer1
     bsf   flags2, fBatMeasure
     return

ShowButtonDown
LoopShowTemp
     btfss flags0, fShowCal
     goto  LoopShowGas1
     bcf   flags0, fShowCal
     bsf   flags0, fShowGas1  
     movlf chr_C,char1
     movlf chr_H,char2
     movlf .4,char3
     goto  LoopShowStatus
LoopShowGas1
     btfss flags0, fShowGas1
     goto  LoopShowGas2
     bcf   flags0, fShowGas1
     bsf   flags0, fShowGas2 
     movlf chr_L,char1
     movlf chr_P,char2
     movlf chr_G,char3
     goto  LoopShowStatus
LoopShowGas2
     btfss flags0, fShowGas2
     goto  LoopShowBatt
     bcf   flags0, fShowGas2
     bsf   flags0, fShowBatt
     movlf chr_b,char1
     movlf chr_A,char2
     movlf chr_t,char3
     goto  LoopShowStatus
LoopShowBatt
     btfss flags0, fShowBatt
     goto  LoopShowCal
     bcf   flags0, fShowBatt
     bsf   flags0, fShowTemp
     movlf chr_t,char1
     movlf chr_E,char2
     movlf chr_gr,char3
     goto  LoopShowStatus
LoopShowCal
     btfss flags0, fShowTemp
     goto  LoopShowInit
     bcf   flags0, fShowTemp
     bsf   flags0, fShowCal
     movlf chr_C,char1
     movlf chr_A,char2
     movlf chr_L,char3
     goto  LoopShowStatus
LoopShowInit
     bcf   flags0, fShowNone
     bcf   flags0, fShowTemp
     bcf   flags0, fShowHum
     bsf   flags0, fShowGas1
     bcf   flags0, fShowGas2
     bcf   flags0, fShowBatt
     bcf   flags0, fShowCal

LoopShowStatus    
     bsf   flags1, fShowButton
     clrf  chardot
     movlf .40,ereg    
DoShowStatus
     call  Delay50ms
     btfss button_Port,Button
     return
     decfsz ereg,F
     goto  DoShowStatus
     return

WaitButtonConfirm
     clrwdt
     btfsc button_Port,Button
     goto  WaitButtonConfirm
     call  Delay200ms
     btfsc button_Port,Button
     goto  WaitButtonConfirm
     call  Delay200ms
     btfsc button_Port,Button
     goto  WaitButtonConfirm
     return

CheckButtonDown
     bcf   flags1, fButtonDwn
     btfsc button_Port,Button
     return
     call  Delay200ms
     btfsc flags1, fButtonDwn
     return
     call  Delay200ms
     btfsc flags1, fButtonDwn
     return
     bsf   flags1, fButtonDwn
     return


show_display_temp
     clrf  chardot
     btfsc flags2,fMinusTemp
     goto  show_display_temp_minus
show_display_temp_plus
     movfw TempVal
     sublw .99
     btfsc STATUS,C 
     goto  show_display_temp99
     movfw TempVal
     movwf DivLo
     movlw .10
     call  Div8
     movfw DivRem
     movwf char3
     movfw DivLo
     movlw .10
     call  Div8
     movfw DivLo
     movwf char1
     movfw DivRem
     movwf char2
     return
show_display_temp99
     movlw b'00000010'
     movwf chardot
     movfw TempVal
     movwf DivLo
     movlw .10
     call  Div8
     movfw DivLo
     movwf char1
     movfw DivRem
     movwf char2
     movfw TempDec
     movwf char3
     return
show_display_temp_minus
     movlf chr_minus,char1
     movfw TempVal
     sublw .10
     btfsc STATUS,C 
     goto  show_display_temp_minus_dot
     movfw TempVal
     movwf DivLo
     movlw .10
     call  Div8
     movfw DivLo
     movwf char2
     movfw DivRem
     movwf char3
     return
show_display_temp_minus_dot
     movlw b'00000010'
     movwf chardot
     movfw TempVal
     movwf char2
     movfw TempDec
     movwf char3
     return


ShowHeat 
     movfw PreHeat
     btfss STATUS,Z
     goto  ShowHeat1
     bcf   flags1, fPreHeat
     return
ShowHeat1
     movfw ctimer1
     sublw .15    
     btfsc STATUS,C 
     return
     clrf  ctimer1
     decf  PreHeat,F
     movfw PreHeat
     call  show_value_plus
     return

ShowMeasure
     btfsc flags0, fShowTemp
     goto  show_display_temp
     btfsc flags0, fShowGas1
     goto  show_display_gas
     btfsc flags0, fShowGas2
     goto  show_display_gas
     btfsc flags0, fShowBatt
     goto  show_display_batt
     return

show_display_gas
     clrf  chardot
     movfw GasCon
     sublw .9
     btfss STATUS,C 
     goto  show_display_gas_error
     movlw b'00000001'  
     movwf chardot
     btfsc flags2,fMinusGas
     goto  show_minus_gas
     movfw GasCon
     andlw b'00001111'
     movwf char1
     goto  show_cont_gas
show_minus_gas
     movlw chr_o
     movwf char1
show_cont_gas
     swapf GasConDec,W
     andlw b'00001111'
     movwf char2
     movfw GasConDec
     andlw b'00001111'
     movwf char3
     return
show_display_gas_error
     movlw .99
     call  show_display_error
     return

show_display_batt
     movlw b'00000001'        
     movwf chardot
     movfw BattVolt
     andlw b'00001111'
     movwf char1
     swapf BattVoltDec,W
     andlw b'00001111'
     movwf char2
     movfw BattVoltDec
     andlw b'00001111'
     movwf char3
     return
     movfw BattVolt
     andlw b'11110000'
     movwf ereg
     swapf ereg,W
     movwf DivLo
     movlw .10
     call  Div8
     movfw DivLo
     btfsc STATUS,Z
     movlw chr_blank
     movwf char1
     movfw DivRem
     movwf char2
     movfw BattVolt
     andlw b'00001111'
     movwf char3
     return

show_display_error
     movwf  DivLo
     movlw  .10
     call   Div8
     movfw  DivLo
     movwf  char2
     movfw  DivRem
     movwf  char3
     movlf chr_E,char1
     clrf  chardot
     return

show_value_plus
     movwf  DivLo
     movlw  .100
     call   Div8
     movfw  DivLo
     btfsc  STATUS,Z
     movlw  chr_blank
     movwf  char1

     movfw  DivRem
     movwf  DivLo
     movlw  .10
     call   Div8
     movfw  DivLo
     btfsc  STATUS,Z
     call   checkblank1
     movwf  char2
     movfw  DivRem
     movwf  char3
     return

checkblank1
     movfw  char1
     sublw  chr_blank
     btfsc  STATUS,Z
     goto   checkblank10
     movfw  DivLo
     return
checkblank10
     movlw  chr_blank
     return


BeepOFF
     bcf   flags2, fBeepEnable
     bcf   flags2, fBeepHi
     bcf   flags2, fBeepMid
     bcf   flags2, fBeepLo
     return

BeepLo
     btfsc flags2, fBeepLo
     return                  
     bcf   flags2, fBeepHi
     bcf   flags2, fBeepMid
     bsf   flags2, fBeepLo
     movlw .1
     movwf SirenOnMax
     movwf SirenTmr
     movlw .20
     movwf SirenOffMax
     bsf   flags2, fBeepEnable
     return

BeepMid
     btfsc flags2, fBeepMid
     return                  
     bcf   flags2, fBeepHi
     bsf   flags2, fBeepMid
     bcf   flags2, fBeepLo
     movlw .1
     movwf SirenOnMax
     movwf SirenTmr
     movlw .10
     movwf SirenOffMax
     bsf   flags2, fBeepEnable
     return

BeepHi
     btfsc flags2, fBeepHi
     return                 
     bsf   flags2, fBeepHi
     bcf   flags2, fBeepMid
     bcf   flags2, fBeepLo
     movlw .1
     movwf SirenOnMax
     movwf SirenTmr
     movlw .1
     movwf SirenOffMax
     bsf   flags2, fBeepEnable
     return

Beep
     btfss flags2, fBeepEnable
     return
     btfsc flags2, fBeepPause
     goto  Beep0
     movfw SirenTmr
     btfss STATUS,Z
     return
     movfw SirenOffMax
     movwf SirenTmr
     bsf   flags2, fBeepPause
     return
Beep0
     movfw SirenTmr
     btfss STATUS,Z
     return
     movfw SirenOnMax
     movwf SirenTmr
     bcf   flags2, fBeepPause
     return



CheckBattTemp
     btfss flags2, fBatMeasure
     return
     bcf   flags2, fBatMeasure   
     call  CheckLM19
     movlw b'00001000' 
     call ReadADC
     bcf  flags0,fLoBatt
     movfw ADCL
     movwf ADCBatLo
     movwf DivLo
     movfw ADCH
     movwf ADCBatHi
     movwf DivHi  
     btfsc STATUS,Z 
     goto  BattLow
     subwf VLoBattHi,W
     btfss STATUS,Z 
     goto  BattOK
     movfw ADCL
     subwf VLoBattLo,W 
     btfsc STATUS,C    
     bsf   flags0, fLoBatt 
BattOK                
     movfw VBattDiv16  
     call  Div16
     movfw DivLo
     movwf BattVolt
     movfw DivRem
     movwf DivD  
     movlw .10
     call  Mul8      
     movfw VBattDiv16 
     call  Div16
     movfw DivLo
     movwf BattVoltDec
     swapf BattVoltDec,f
     movfw DivRem
     movwf DivD  
     movlw .10
     call  Mul8     
     movfw VBattDiv16 
     call  Div16
     movfw DivLo
     iorwf BattVoltDec,f
     btfss flags0, fLoBatt
     return
BattLow
     clrf  chardot
     movlf chr_b,char1
     movlf chr_L,char2
     movlf .0,char3
     return


CheckLM19
     movlw b'00000100' 
     call  ReadADC    
     bcf   flags2,fMinusTemp
     movfw ADCL
     movwf ADCTempLo
     movfw ADCH
     movwf ADCTempHi
     subwf VZeroLM19Hi,W
     btfss STATUS,C
     goto  CheckLM19minus  
     btfss STATUS,Z
     goto  CheckLM19plus
     movfw ADCL
     subwf VZeroLM19Lo,W
     btfss STATUS,C
     goto  CheckLM19minus 
CheckLM19plus
     movfw VZeroLM19Hi
     movwf DivHi
     movfw VZeroLM19Lo
     movwf DivLo
     movfw ADCH
     movwf DivD
     movfw ADCL
     movwf DivRem
     goto  CheckLM19calc
CheckLM19minus
     bsf   flags2,fMinusTemp
     movfw ADCH
     movwf DivHi
     movfw ADCL
     movwf DivLo
     movfw VZeroLM19Hi
     movwf DivD
     movfw VZeroLM19Lo
     movwf DivRem
CheckLM19calc
     call  Sub16 
     movfw DivLo
     movwf MulLo
     movfw DivHi
     movwf MulHi
     movlw .10
     call  Mul16
     movfw MulHi
     movwf DivHi
     movfw MulLo
     movwf DivLo
     movfw VDivLM19
     call  Div16
     movfw DivLo
     movwf TempVal
     movfw DivRem
     movwf MulLo
     clrf  MulHi
     movlw .10
     call  Mul16
     movfw MulHi
     movwf DivHi
     movfw MulLo
     movwf DivLo
     movfw VDivLM19 
     call  Div16
     movfw DivLo
     movwf TempDec
     return

ClearAvgGas
     clrf   VADCGidx
     movlw  ADCGcnt
     movwf  crcbit
     movlw  VADCGas
     movwf  FSR
ClearAvgGas0
     clrf   INDF        
     incf   FSR,F
     decfsz crcbit,F
     goto   ClearAvgGas0
     return

CalcGasAvg    
     movlw  VADCGas		 
     addwf  VADCGidx,W   
     incf   VADCGidx,F	 
     movwf  FSR          
     movff  ADCGasLo,INDF
     incf   VADCGidx,F    
     incf   FSR,F
     movff  ADCGasHi,INDF
     movlw  ADCGcnt
     subwf  VADCGidx,W
     btfsc  STATUS,C     
     clrf   VADCGidx
     movlw  ADCGccnt     
     movwf  crcbit
     movlw  VADCGas		
     movwf  FSR         
     clrf   VADCGasHi
     clrf   VADCGasLo
CalcGasAvg0
     movfw  INDF        
     incf   FSR,F     
     addwf  VADCGasLo,F
     btfsc  STATUS,C
     incf   VADCGasHi,F
     movfw  INDF        
     incf   FSR,F 
     addwf  VADCGasHi,F
     decfsz crcbit,F
     goto   CalcGasAvg0
     movfw VADCGasHi
     movwf DivHi
     movfw VADCGasLo
     movwf DivLo
     movlw  ADCGccnt    
     movwf  crcbit
     call   Div16
     movfw  DivHi
     movwf  VADCGasHi
     movfw  DivLo
     movwf  VADCGasLo
     return 

Gas0_1 EQU .73  
Gas1_1 EQU .147 
Gas2_1 EQU .122 

CheckGas  
     bcf   flags2,fMinusGas
     movlw .0         
     call ReadADC
     movfw ADCL
     movwf ADCGasLo
     movwf VADCGasLo
     movfw ADCH
     movwf ADCGasHi
     movwf VADCGasHi
     call  CalcGasAvg
     movfw VZeroGasHi
     subwf VADCGasHi,W
     btfss STATUS,C
     goto  CheckGasminus  
     btfss STATUS,Z
     goto  CheckGasplus
     movfw VZeroGasLo
     subwf VADCGasLo,W
     btfss STATUS,C
     goto  CheckGasminus 
CheckGasplus
     movfw VZeroGasLo
     subwf VADCGasLo,F
     movfw VZeroGasHi
     btfss STATUS,C
     decf  VADCGasHi,F 
     subwf VADCGasHi,F 
     goto  CheckGascalc
CheckGasminus
     bsf   flags2,fMinusGas
     movfw VADCGasLo
     subwf VZeroGasLo,W
     movwf VADCGasLo
     movfw VADCGasHi
     btfss STATUS,C
     decf  VADCGasHi,F
     subwf VZeroGasHi,W
     movwf VADCGasHi
CheckGascalc
     movfw VADCGasHi
     movwf DivHi
     movfw VADCGasLo
     movwf DivLo
     movlw Gas0_1
     btfsc flags1, fMeasureG1
     movlw Gas1_1
     btfsc flags1, fMeasureG2
     movlw Gas2_1
     call  Div16
     movfw DivLo
     movwf GasCon
     movfw DivRem
     movwf DivD
     movlw .10
     call  Mul8
     movlw Gas0_1
     btfsc flags1, fMeasureG1
     movlw Gas1_1
     btfsc flags1, fMeasureG2
     movlw Gas2_1
     call  Div16
     movfw DivLo
     movwf GasConDec
     swapf GasConDec,f
     movfw DivRem
     movwf DivD
     movlw .10
     call  Mul8
     movlw Gas0_1
     btfsc flags1, fMeasureG1
     movlw Gas1_1
     btfsc flags1, fMeasureG2
     movlw Gas2_1
     call  Div16
     movfw DivLo
     iorwf GasConDec,f
CheckGasHi
     movfw GasCon
     btfsc STATUS,Z
     goto  CheckGasMid
     call  BeepHi
     return
CheckGasMid
     swapf GasConDec,W
     andlw b'00001111'
     sublw .4
     btfsc STATUS,C
     goto  CheckGasLo
     call  BeepMid
     return
CheckGasLo  
     swapf GasConDec,W
     andlw b'00001111'
     btfsc STATUS,Z
     goto  CheckGasOFF
     call  BeepLo
     return
CheckGasOFF
     call  BeepOFF
     return

UpdateDispDot  
     andwf chardot,w
     btfsc STATUS,Z
     return
     movlw b'11110111'
     andwf dreg,f
     return

UpdateDisplay
     movff char1,dispchar1
     movff char2,dispchar2
     movff char3,dispchar3
     btfsc PORTB,Anode1  
     goto  UpdateDisplay2
     btfsc PORTB,Anode2  
     goto  UpdateDisplay3
UpdateDisplay1
     bcf   PORTB,Anode2
     bcf   PORTA,Anode3
     movlf HIGH chars,PCLATH
     fwcall dispchar1,chars
     movwf dreg
     movlw b'00000001'
     call  UpdateDispDot
     movfw dreg
     movwf PORTC
     bsf   PORTB,Anode1
     goto  UpdateDisplayRet 
UpdateDisplay2
     bcf   PORTB,Anode1
     bcf   PORTA,Anode3
     movlf HIGH chars,PCLATH
     fwcall dispchar2,chars
     movwf dreg
     movlw b'00000010'
     call  UpdateDispDot
     movfw dreg
     movwf PORTC
     bsf   PORTB,Anode2
     goto  UpdateDisplayRet  
UpdateDisplay3
     bcf   PORTB,Anode1
     bcf   PORTB,Anode2
     movlf HIGH chars,PCLATH
     fwcall dispchar3,chars
     movwf dreg
     movlw b'00000100'
     call  UpdateDispDot
     movfw dreg
     movwf PORTC
     bsf   PORTA,Anode3
     goto  UpdateDisplayRet  
UpdateDisplayRet
     return


CheckUSART
     movlw rxlength
     subwf rxbuf,W
     btfss STATUS,C      
     return
     bcf   RCSTA,CREN    
     movff rxbuf,creg
     clrf  rxbuf         
cmd0    
     cmprxb1 .0,cmd1     
     call  SendBuffer    
     goto  CheckUSARTEx
cmd1
     cmprxb1 .1,cmd2
     call  SendVersion
     goto  CheckUSARTEx
cmd2
     cmprxb1 .2,cmd3
     call  SendCRLF      
     goto  $             
     goto  Start         
     goto  CheckUSARTEx
cmd3
     cmprxb1 .3,cmd4
     movfw rxbuf+2
     movwf char1
     movfw rxbuf+3
     movwf char2
     movfw rxbuf+4
     movwf char3
     movfw rxbuf+5
     movwf chardot
     clrf  flags0
     bsf   flags0, fShowNone
     goto  CheckUSARTEx
cmd4
     cmprxb1 .4,cmd5
     call  WriteEpromByte
     goto  CheckUSARTEx
cmd5
     cmprxb1 .5,cmd6
     call  ReadEpromByte
     goto  CheckUSARTEx
cmd6
     cmprxb1 .6,cmd7
     call  WriteEpromByte8
     goto  CheckUSARTEx
cmd7
     cmprxb1 .7,cmd8
     call  ReadEpromByte8
     goto  CheckUSARTEx
cmd8
     cmprxb1 .8,cmd9
     goto  CheckUSARTEx
cmd9
     cmprxb1 .9,cmd10
     goto  CheckUSARTEx
cmd10
     cmprxb1 .10,cmd11
     call  GetPortsState
     goto  CheckUSARTEx
cmd11
     cmprxb1 .11,cmd12
     movfw ADCBatHi
     call  SendChar
     movfw ADCBatLo
     call  SendChar
     movfw VZeroGasHi
     call  SendChar
     movfw VZeroGasLo
     call  SendChar
     movfw ADCGasHi
     call  SendChar
     movfw ADCGasLo
     call  SendChar
     movfw ADCTempHi
     call  SendChar
     movfw ADCTempLo
     call  SendChar
     goto  CheckUSARTEx
cmd12
     cmprxb1 .12,cmd20
     movfw rxbuf+2
     movwf flags0
     goto  CheckUSARTEx

cmd20
     cmprxb1 .20,cmd21
     bcf   flags2, fBeepEnable
     bcf   flags2, fBeepPause
     movfw rxbuf+2
     movfw rxbuf+3
     movwf SirenOnMax
     movwf SirenTmr
     movfw rxbuf+4
     movwf SirenOffMax     
     movfw rxbuf+5
     btfss STATUS,Z
     bsf   flags2, fBeepEnable
     goto  CheckUSARTEx
cmd21
     cmprxb1 .21,cmd22
     goto  CheckUSARTEx
cmd22
     cmprxb1 .22,cmd23
     goto  CheckUSARTEx
cmd23
     cmprxb1 .23,cmd24
     goto  CheckUSARTEx
cmd24
     cmprxb1 .24,cmd25
     movfw rxbuf+2
     goto  CheckUSARTEx
cmd25
     cmprxb1 .25,cmd26
     movfw rxbuf+2
     movfw BattVolt
     call  SendChar
     movfw BattVoltDec
     call  SendChar
     movfw GasCon
     call  SendChar
     movfw GasConDec
     call  SendChar
     movfw TempVal
     call  SendChar
     movfw TempDec
     call  SendChar
     movfw flags0
     call  SendChar
     movfw flags1
     call  SendChar
     movfw flags2
     call  SendChar
     goto  CheckUSARTEx
cmd26
     lwcall 'N',SendChar
     lwcall 'I',SendChar
CheckUSARTEx
     call  SendCRLF
     clrf  rxbuf
     bsf   RCSTA,CREN   
     return


ReadADC
     iorlw b'10000001' 
     movwf ADCON0     
     call  Delay50ms  
     bsf   ADCON0,GO_DONE 
ReadADC_done
     btfsc ADCON0,GO_DONE 
     goto  ReadADC_done
     movff ADRESH,ADCH
 disable_bank_warn
     bsf   STATUS,RP0     
     movfw ADRESL
     bcf   STATUS,RP0     
 enable_bank_warn
     movwf ADCL
     bcf   PIR1,ADIF
     return


GetPortsState
     fwcall PORTC,SendChar
     fwcall PORTB,SendChar
     fwcall PORTA,SendChar
     fwcall flags0,SendChar
     fwcall flags1,SendChar
     fwcall flags2,SendChar
     return

SendBuffer
     fwcall creg,SendChar
     movlf rxbuf,FSR    
SendBuffer1
     incf  FSR,F
     fwcall INDF,SendChar
     decfsz creg,F
     goto  SendBuffer1
     return

SendVersion
     clrf  CTMP0
SendVersion1
     movlf HIGH version,PCLATH
     fwcall CTMP0,version
     andlw 0xFF
     btfsc STATUS,Z
     return
     call  SendChar        
     incf  CTMP0,F
     goto  SendVersion1

SendCRLF
     lwcall crchar,SendChar
     lwcall lfchar,SendChar
     return


Delay01ms_
     movwf DTMP1
NNN1 movlf .33,DTMP3 
NNN2 decfsz DTMP3,F                
     goto  NNN2
     decfsz DTMP1,F                
     goto  NNN1
     return


Delay50ms_ 
     movwf DTMP1
N0   movlf .100,DTMP2   
     clrwdt
N1   movlf .120,DTMP3   
N2   clrwdt             
     decfsz DTMP3,F     
     goto  N2           
     decfsz DTMP2,F
     goto  N1
     decfsz DTMP1,F                
     goto  N0
     return

Delay1ms_
     movwf DTMP1
NN0  movlf .2,DTMP2     
     clrwdt
NN1  movlf .160,DTMP3   
NN2  decfsz DTMP3,F                
     goto  NN2
     decfsz DTMP2,F
     goto  NN1
     decfsz DTMP1,F                
     goto  NN0
     return

Delay01ms
#ifdef use_4MHz
     lwcall .1,Delay01ms_
#else
     lwcall .2,Delay01ms_
#endif
     return

Delay1ms
#ifdef use_4MHz
     lwcall .1,Delay1ms_
#else
     lwcall .2,Delay1ms_
#endif
     return

Delay20ms
#ifdef use_4MHz
     lwcall .20,Delay1ms_
#else
     lwcall .40,Delay1ms_
#endif
     return

Delay50ms
#ifdef use_4MHz
     lwcall .1,Delay50ms_
#else
     lwcall .2,Delay50ms_
#endif
     return

Delay80ms
#ifdef use_4MHz
     lwcall .80,Delay1ms_
#else
     lwcall .160,Delay1ms_
#endif
     return


Delay100ms
#ifdef use_4MHz
     lwcall .2,Delay50ms_
#else
     lwcall .4,Delay50ms_
#endif
     return

Delay200ms
#ifdef use_4MHz
     lwcall .4,Delay50ms_
#else
     lwcall .8,Delay50ms_
#endif
     return

Delay1s
#ifdef use_4MHz
     lwcall .20,Delay50ms_
#else
     lwcall .40,Delay50ms_
#endif
     return


WriteEpromByte
     fwcall rxbuf+2,SetEpromAddr
     fwcall rxbuf+3,WriteEprom
     return

ReadEpromByte
     fwcall rxbuf+2,ReadEprom
     call  SendChar
     return

WriteEpromByte8
     movlf rxbuf+3,FSR        
     movlf .8,ereg
web8
     fwcall rxbuf+2,SetEpromAddr
     fwcall INDF,WriteEprom 
     incf  FSR,F
     incf  rxbuf+2,F
     decfsz ereg,F
     goto web8
     return

ReadEpromByte8
     movlf .8,ereg
reb8
     fwcall rxbuf+2,ReadEprom  
     call  SendChar
     incf  rxbuf+2,F
     decfsz ereg,F
     goto reb8
     return

disable_bank_warn

ReadEprom                
     bsf   STATUS, RP1   
     bcf   STATUS, RP0   
     movwf EEADR         
     bsf   STATUS, RP0   
     bcf   EECON1, EEPGD 
     bsf   EECON1, RD    
     bcf   STATUS, RP0   
     movfw EEDATA        
     bcf   STATUS, RP1   
     return

SetEpromAddr             
     bsf   STATUS, RP1   
     bcf   STATUS, RP0   
     movwf EEADR         
     bcf   STATUS, RP1   
     return

WriteEprom              
     bsf   STATUS, RP1  
     bcf   STATUS, RP0  
     movwf EEDATA         
     bsf   STATUS, RP0    

     bcf   EECON1, EEPGD  
     bsf   EECON1, WREN   
TryGIE
     bcf   INTCON, GIE    
     btfsc INTCON, GIE    
     goto  $-2            
     movlw 0x55           
     movwf EECON2         
     movlw 0xAA           
     movwf EECON2         
     bsf   EECON1,WR      
     bsf   INTCON, GIE    
     btfsc EECON1,WR      
     goto  $-1
     bcf   EECON1, WREN   
     btfsc EECON1,WRERR
     goto  WriteEpromError
     bcf   STATUS, RP1    
     bcf   STATUS, RP0    
     return

WriteEpromError
     bcf   EECON1,WRERR
     bcf   STATUS, RP1  
     bcf   STATUS, RP0  
     lwcall 'E',SendChar
     return
 
 enable_bank_warn


 cblock
  MathLoopCnt,MthTmp0,MthTmp1
  DivLo,DivHi,DivRem,DivD
  MulLo,MulHi,MulHih,MulPl,MulPx
 endc

Sub16
     movfw DivRem
     subwf DivLo,F
     movfw DivD
     btfss STATUS,C
     decf  DivHi,F 
     subwf DivHi,F 
     return

Mul8
     movwf DivRem
     clrf  DivHi
     clrf  DivLo
     movlw .8
     movwf MathLoopCnt
     movfw DivRem
     bcf   STATUS,C
Mul8_1
     rrf   DivD,F
	 btfsc STATUS,C
	 addwf DivHi,F
	 rrf   DivHi,F
	 rrf   DivLo,F
	 decfsz MathLoopCnt,F
     goto  Mul8_1
     return

Mul16
     movwf MulPx
     movfw MulLo
     movwf MthTmp0
     movfw MulHi
     movwf MthTmp1
     clrf  MulHih
     clrf  MulHi
     clrf  MulLo
     bsf   MulLo,7
Mul16_0
     rrf   MulPx,F
     skpc
     goto Mul16_1
     movfw MthTmp0
     addwf MulHi,F
     movfw MthTmp1
     skpnc
     incfsz MthTmp1,W
     addwf MulHih,F
Mul16_1
     rrf MulHih,F
     rrf MulHi,F
     rrf MulLo,F
     skpc
     goto Mul16_0
     return

Div8
     movwf DivD
     clrf  DivRem
     movlw .8
     movwf MathLoopCnt
Div8_0
     rlf   DivLo,W
     rlf   DivRem,F
     movfw DivD
     subwf DivRem,F
     btfsc STATUS,C
     goto  Div8_1          
     addwf DivRem,F
     bcf   STATUS,C
Div8_1
     rlf   DivLo,F
     decfsz MathLoopCnt,F
     goto  Div8_0
     movfw DivLo
     return

RoundDiv8
    movfw  DivRem
    sublw  .4
    btfsc  STATUS,C
    return
    incf   DivLo,F
    return

Div16
     clrf  DivRem
     movwf DivD
     addlw .0
     btfsc STATUS,Z    
     goto  Div16_4
     movlw .8
     movwf MathLoopCnt
Div16_0      
     rlf   DivHi,W
     rlf   DivRem,F
     movfw DivD
     subwf DivRem,F
     btfsc STATUS,C
     goto  Div16_1          
     addwf DivRem,F
     bcf   STATUS,C
Div16_1
     rlf   DivHi, F
     decfsz MathLoopCnt,F
     goto  Div16_0
     clrf  MthTmp0
     movlw .8
     movwf MathLoopCnt
Div16_2
     rlf   DivLo,W
     rlf   DivRem, F
     rlf   MthTmp0, F
     movfw DivD
     subwf DivRem, F
     clrf  MthTmp1
     clrw
     btfss STATUS,C
     incfsz MthTmp1,W
     subwf MthTmp0,F
     btfsc STATUS,C
     goto  Div16_3
     movfw DivD
     addwf DivRem,F
     clrf  MthTmp1
     clrw
     btfsc STATUS,C
     incfsz MthTmp1,W
     addwf MthTmp0,F
     bcf   STATUS,C
Div16_3
     rlf   DivLo,F
     decfsz MathLoopCnt,F
     goto  Div16_2
     movfw DivLo
     bcf   STATUS,Z
     return
Div16_4                
     clrw
     clrf  DivHi
     clrf  DivLo
     bsf   STATUS,Z
     return


     ORG 0x7B0
chars
     addwf PCL,F
     retlw b'00001010' 
     retlw b'11111010' 
     retlw b'01001100' 
     retlw b'01101000' 
     retlw b'10111000' 
     retlw b'00101001' 
     retlw b'00001001' 
     retlw b'01111010' 
     retlw b'00001000' 
     retlw b'00101000' 
     retlw b'11111101' 
     retlw b'11111111' 
     retlw b'00000000' 
     retlw b'01101111' 
     retlw b'01101101' 
     retlw b'10011010' 
     retlw b'00011000' 
     retlw b'00001111' 
     retlw b'00001101' 
     retlw b'00011101' 
     retlw b'10011000' 
     retlw b'10011111' 
     retlw b'11001010' 
     retlw b'10001111' 
     retlw b'00011100' 
     retlw b'00101001' 
     retlw b'10001010' 
     retlw b'10001001' 
     retlw b'11001101' 
     retlw b'11001000' 
     retlw b'10011001' 
     retlw b'11011111' 
     retlw b'11011001' 
     retlw b'11001001' 
     retlw b'11011101' 
     retlw b'10001101' 
     retlw b'11001011' 
     retlw b'11011100' 
     retlw b'00111100' 
     retlw b'10111110' 
     retlw b'00001111' 
     retlw b'01101010' 
     retlw b'11001011' 
     retlw b'00111110' 
     retlw b'00001011' 


     ORG 0x7E0
version   
     addwf PCL,F
     dt "Gas Detector v1.0",0

     ORG 0x800

UpdateCRC
     xorwf crcbit,F
     movlf HIGH crc8table,PCLATH
     movfw crcbit
    pagesel crc8tablecompute
    call crc8tablecompute
    pagesel UpdateCRC
     movwf crcbit
     return

UpdateEpromCRC
 disable_cpage_warn
     pagesel ReadEprom
     call  ReadEprom
     pagesel UpdateCRC
 enable_cpage_warn
     call  UpdateCRC
     return

CalcEpromCRC
     clrf  crcbit
     clrf  creg
CalcEpromCRC0
     movfw creg
     call  UpdateEpromCRC
     incf  creg,F
     movlw .15
     subwf creg,W
     btfss STATUS,Z
     goto  CalcEpromCRC0
 disable_cpage_warn
     pagesel ReadEprom
     movlw .15
     call  ReadEprom        
     pagesel CalcEpromCRC
 enable_cpage_warn
     subwf crcbit,w
     btfsc STATUS,Z
     return
     bsf   flags1,fCRCError
     return


     ORG 0xEFF
#include <crc8tbl.inc>



 END

