unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls, ExtCtrls, inifiles, unitx;

type

  TReplyData = record
   BattVolt: byte;
   BattVoltDec: byte;
   GasCon: byte;
   GasConDec: byte;
   TempVal: byte;
   TempDec: byte;
   flags0, flags1, flags2: byte;
  end;

  TADCData = record
   ADCBatHi: byte;
   ADCBatLo: byte;
   VZeroGasHi: byte;
   VZeroGasLo: byte;
   ADCGasHi: byte;
   ADCGasLo: byte;
   ADCTempHi: byte;
   ADCTempLo: byte;
  end;

  TReadThread = class(TThread)
  public
   fs: string;
   constructor Create;
   procedure Execute; override;
   procedure ShowStr;
  end;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    sb1: TStatusBar;
    device1: TMenuItem;
    m: TMemo;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Panel1: TPanel;
    Info1: TMenuItem;
    N2: TMenuItem;
    Restart1: TMenuItem;
    data1: TMenuItem;
    N1: TMenuItem;
    Label5: TLabel;
    Portsstatus1: TMenuItem;
    Timer1: TTimer;
    GetADCdata1: TMenuItem;
    Label1: TLabel;
    gc: TLabel;
    Label2: TLabel;
    temp: TLabel;
    MeasureTimerOnOff1: TMenuItem;
    Label4: TLabel;
    pwr: TLabel;
    getvalues1: TMenuItem;
    Show1: TMenuItem;
    Gas11: TMenuItem;
    Gas21: TMenuItem;
    Batteryvoltage1: TMenuItem;
    Temperature2: TMenuItem;
    Setconfig1: TMenuItem;
    DoCALibration1: TMenuItem;
    N3: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Restart1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Portsstatus1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure GetADCdata1Click(Sender: TObject);
    procedure MeasureTimerOnOff1Click(Sender: TObject);
    procedure getvalues1Click(Sender: TObject);
    procedure Gas11Click(Sender: TObject);
    procedure Gas21Click(Sender: TObject);
    procedure Batteryvoltage1Click(Sender: TObject);
    procedure Temperature2Click(Sender: TObject);
    procedure Setconfig1Click(Sender: TObject);
    procedure DoCALibration1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
   procedure AddStr(s:string);
   function  OpenPort: boolean;
   procedure SendCmd(cmd: string; chars: byte);
  end;

const
  rcvsize=10000;

type
  rcvbuf = array [0..rcvsize] of char;
  tshowdata=(shhex,shbinary,shascii);

var
  Form1: TForm1;
  nrcv: cardinal;
  rcv: rcvbuf;

implementation

uses Unit3;


{$R *.DFM}


const
  initsection='init';

  cmdlength = 10;
  infocmd = #1;
  resetdevice = #2;
  show_display = #3;
  write_eprom_byte8 = #6;
  read_eprom_byte8 = #7;
  get_port_status = #10;
  get_adc_data = #11;
  show_display_data = #12;
  get_data = #25;

  comhandle: thandle= 0;
  readthread: treadthread = nil;
  portopen: boolean = false;
  showsend: boolean = false;
  showdata: tshowdata = shhex;
  showcrlf: boolean = false;
  showlog: boolean = true;
  autoopen: boolean = true;
  loglines: integer = 100;
  savelog: boolean = true;
  enabletimer: boolean = false;
  rtimer: integer = 60;
  ctimer: integer = 0;

var
  inifilepth: string;


constructor TReadThread.Create;
begin
 inherited Create(true);
 freeonterminate := true;
 priority := tpNormal;
 resume;
end;

procedure TReadthread.ShowStr;
begin
 if (Form1 <> nil) and (fs <> '') then Form1.addstr('R: '+ fs);
end;

procedure TReadthread.Execute;
var i: integer;
    r: array [0..rcvsize] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 repeat
try
  if ClearCommError(comhandle,cst,@st) then begin
    sleepex(10,true);
    if st.cbInQue > 0 then begin
      if readfile(comhandle, r, sizeof(r)-1, nr, nil) then begin

       if nrcv + nr > rcvsize then begin
        fs := 'Buffer full'; Synchronize(ShowStr);
        nrcv := 0;
        if nr > rcvsize then continue; // discard chars
       end;

        move(r[0],rcv[nrcv],nr); nrcv := nrcv + nr;  fs := '';
        if nr <> 0 then begin
         for i := 0 to nr-1 do begin
          case showdata of
           shhex: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + inttohex(byte(r[i]),2);
           end;
           shbinary: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + binb(byte(r[i]));
           end;
           shascii: begin
            if r[i] = #13 then fs := fs + '<CR>' else
            if r[i] = #10 then fs := fs + '<LF>' else
            if r[i] in [#32..#126] then fs := fs + r[i] else
              fs := fs + '0x'+inttohex(byte(r[i]),2);
           end;
          end;
          if showdata <> shascii then fs := fs + ' ';
         end;
          Synchronize(ShowStr);
        end;
      end;
    end;
  end;
except
 on e: exception do ebox('Thread '+e.message);
end;
 until application.Terminated or terminated;
end;




function waitrcv(chars: byte): boolean;
var t: tdatetime;
    timeout: boolean;
begin
 t := now + 2/(24*3600);
 repeat
  sleepex(100,true);
  timeout := t < now;
  application.ProcessMessages;
 until (nrcv >= chars) or timeout;
 if timeout then result := false else result := true;
end;

function DoOpenPort(var ph: thandle): boolean;
var dcb: tdcb;
    t:COMMTIMEOUTS;
    f: TIniFile;
    c: string;
    brate: integer;
begin
 result := false;
 f := tinifile.create(inifilepth);
try
 c := uppercase(f.ReadString(initsection,'port','\\.\COM1'));
 brate := f.ReadInteger(initsection,'baud',19200);

finally
 f.free;
end;
 ph := CreateFile(pchar(c),
    GENERIC_READ or GENERIC_WRITE, 0,nil, OPEN_EXISTING, 0, 0);

 if ph = INVALID_HANDLE_VALUE then begin
  ebox('CreateFile INVALID_HANDLE_VALUE'#13+syserrormessage(GetLastError));
  exit;
 end;

 dcb.DCBlength := sizeof(dcb);
 if not GetCommState(ph, dcb) then
  begin
   ebox('ComHandle GetCommState '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 dcb.BaudRate := brate;
 dcb.Parity := 0;
 dcb.ByteSize := 8;
 dcb.StopBits := ONESTOPBIT;

 if not SetCommState(ph, dcb) then
  begin
   ebox('ComHandle SetCommState '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 EscapeCommFunction(ph, SETDTR);
 EscapeCommFunction(ph, SETRTS);

 if not  getcommtimeouts(ph,t) then
  begin
   ebox('ComHandle GetCommTimeOuts '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 t.ReadIntervalTimeout := 100;
 t.ReadTotalTimeoutMultiplier := 1;

 if not setcommtimeouts(ph, t) then
  begin
   ebox('ComHandle SetCommTimeOuts '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;
{
 if not PurgeComm(ph, PURGE_RXCLEAR or PURGE_TXCLEAR) then begin
  ebox('ComHandle PurgeComm '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
  exit;
 end;
}
 result := true;
end;

procedure ClearCom(h: thandle);
var r: array [0..1000] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 if ClearCommError(comhandle,cst,@st) and (st.cbInQue > 0) then begin
  readfile(h, r, sizeof(r)-1, nr, nil);
 end;
end;

function TForm1.OpenPort: boolean;
begin

 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;

 if comhandle <> 0 then if closehandle(comhandle) then comhandle := 0;
 result := false;

 if not DoOpenPort(comhandle) then exit;

 if not SetCommMask(comhandle, EV_RXCHAR) then begin
  ebox('ComHandle SetCommMask '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
 end;

 sleep(100);
 ClearCom(comhandle);
 readthread := Treadthread.Create;

 result := true;
 portopen := true;
 addstr('COM port opened');
end;


function SendString(s: string): boolean;
var wb: cardinal;
    l: integer;
begin
 result := false;
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 l := length(s);
 if not writefile(comhandle, s[1], l, wb, nil) then begin
  EBox(syserrormessage(getlasterror));
 end else result := true;
end;

procedure TForm1.AddStr(s:string);
var p: string;
begin
 p := formatdatetime('hh:nn:ss dd.mm.yyyy ',now) + s + #13#10;
 if savelog then
  xwritetostringfile(p,_exedir+_exename+'.log');
 if not showlog then exit;
 m.lines.BeginUpdate;
try
 while m.lines.count > loglines do begin
  m.Lines.Delete(m.lines.count-1);
 end;
 m.lines.insert(0,trimright(s));
finally
 m.lines.EndUpdate;
end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 Ibox('Gas Detector service'#13#13'(c) Zelenka 2018');
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close;
end;

const issending: boolean = false;
procedure TForm1.SendCmd(cmd: string; chars: byte);
var s,p: string;
    i: integer;
begin
 if issending then begin
  beep;
  showlog := true;
  addstr('Cmd in progress...');
  exit;
 end;
 issending := true;
try
 sb1.Panels[1].text := '';
 if not portopen then OpenPort;
 for i := length(cmd)+1 to cmdlength do cmd := cmd + #0;
 sb1.Panels[1].text := 'Sending data...';
 p := '';
 for i := 1 to length(cmd) do p := p + '0x'+inttohex(byte(cmd[i]),2)+' ';
 if showsend then addstr('S: '+p)
  else addstr('S: '+inttostr(length(cmd))+'B');
 if sendstring(cmd) then begin
  if waitrcv(chars) then begin
  s := copy(rcv,1,nrcv-2);
  end else begin
   addstr('Receive error!');
   beep;
  end;
 end;
 sb1.Panels[1].Text := p;
finally
 issending := false;
end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
//
end;

procedure TForm1.FormCreate(Sender: TObject);
var f: tinifile;
begin
// fillchar(data,sizeof(data),0);
 decimalseparator := '.';
 m.Clear;
 inifilepth := _exedir+_exename+'.ini';
 f := tinifile.create(inifilepth);
try
 autoopen := f.ReadBool(initsection,'AutoOpen',autoopen);
 loglines := f.ReadInteger(initsection,'LogLines',loglines);
 SaveLog := f.ReadBool(initsection,'SaveLog',SaveLog);
 rtimer := f.ReadInteger(initsection,'Timer',rtimer);
 if rtimer < 10 then rtimer := 10;
 ctimer := rtimer - 10; // measure for next 10s
 enabletimer := f.ReadBool(initsection,'EnableTimer',enabletimer);
 MeasureTimerOnOff1.Checked := enabletimer;
 timer1.Enabled := enabletimer;
finally
 f.free;
end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 EscapeCommFunction(comhandle, CLRRTS);
 EscapeCommFunction(comhandle, CLRDTR);
 if comhandle <> 0 then closehandle(comhandle);
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
 OpenPort;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;
 if comhandle <> 0 then
 if closehandle(comhandle) then begin
  portopen := false;
  comhandle := 0;
 end;
 addstr('COM port closed');
end;

const first:boolean = true;
procedure TForm1.FormActivate(Sender: TObject);
begin
 if first then begin
  first := false;
  if autoopen then OpenPort;
 end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var sl: boolean;
begin
 sb1.Panels[0].text := ' '+inttostr(rtimer-ctimer);
 if rtimer > 0 then begin
  if ctimer >= rtimer then begin
   ctimer := 0;
   sl := showlog;
   try
    showlog := false;
    getvalues1Click(Sender);
   finally
    showlog := sl;
   end;
  end else inc(ctimer);
 end;
end;

procedure TForm1.Restart1Click(Sender: TObject);
begin
 if qbox('Are you sure?') = idyes then begin
  SendCmd(resetdevice,2);
  if nrcv >= 2 then begin
  end else ebox('Restart error!');
 end;
end;

procedure TForm1.Info1Click(Sender: TObject);
var b: tshowdata;
begin
 b := showdata;
 showdata := shascii;
 SendCmd(infocmd,16);
 showdata := b;
end;

procedure TForm1.Portsstatus1Click(Sender: TObject);
begin
 sendcmd(get_port_status,8);
 if nrcv = 8 then begin
  addstr(format('Flags0: %s',[binb(byte(rcv[3]))]));
  addstr(format('Flags1: %s',[binb(byte(rcv[4]))]));
  addstr(format('Flags2: %s',[binb(byte(rcv[5]))]));
  addstr(format('Port A: %s',[binb(byte(rcv[2]))]));
  addstr(format('Port B: %s',[binb(byte(rcv[1]))]));
  addstr(format('Port C: %s',[binb(byte(rcv[0]))]));
 end;
end;

procedure TForm1.GetADCdata1Click(Sender: TObject);
var d: TADCData;
    b,g,go,t: integer;
begin

 sendcmd(get_adc_data,10);
 if nrcv = 10 then begin
  move(rcv,d,sizeof(d));
  b := d.ADCBatHi*256 + d.ADCBatLo;
  go := d.VZeroGasHi*256 + d.VZeroGasLo;
  g := d.ADCGasHi*256 + d.ADCGasLo;
  t := d.ADCTempHi*256 + d.ADCTempLo;
  addstr(format('Batt: 0x%.4x-%d'#13#10+
                'Gas : 0x%.4x-%d Zero offset 0x%.4x-%d'#13#10+
                'Temp: 0x%.4x-%d',
                 [b,b,g,g,go,go,t,t]));

  // calc values

 end else begin
  // error
 end;
end;

procedure TForm1.MeasureTimerOnOff1Click(Sender: TObject);
begin
 MeasureTimerOnOff1.Checked := not MeasureTimerOnOff1.Checked;
 timer1.Enabled := MeasureTimerOnOff1.Checked;
 ctimer := rtimer - 10;
end;

procedure TForm1.getvalues1Click(Sender: TObject);
var d: TReplyData;
    t,p,c: real;
    mg,mt: string;
begin
 sendcmd(get_data,11);
 if nrcv = 11 then begin
  move(rcv,d,sizeof(d));
  t := d.TempVal + d.TempDec / 10;
  p := d.BattVolt + ((d.BattVoltDec and $f0) shr 4) / 10 + ((d.BattVoltDec and $f) / 100);
  c := d.GasCon + ((d.GasConDec and $f0) shr 4) / 10 + ((d.GasConDec and $f) / 100);
  pwr.Caption := format('%0.2fV',[p]);
  if d.flags2 and 8 = 8 then mt := '-' else mt := '';
  if d.flags2 and 16 = 16 then mg := '-' else mg := '';
  if d.flags1 and 8 = 8 then
    gc.Caption := format('%s%0.2f%% CH4',[mg,c])
  else
    gc.Caption := format('%s%0.2f%% LPG',[mg,c]);
  temp.Caption := format('%s%0.1fC',[mt,t]);
 end else begin
  pwr.Caption := '??? V';
  gc.Caption := '??? %';
  temp.Caption := '??? C';
 end;
end;

procedure TForm1.Gas11Click(Sender: TObject);
begin
 sendcmd(show_display_data+#8,2);
end;

procedure TForm1.Gas21Click(Sender: TObject);
begin
 sendcmd(show_display_data+#16,2);
end;

procedure TForm1.Batteryvoltage1Click(Sender: TObject);
begin
 sendcmd(show_display_data+#32,2);
end;

procedure TForm1.Temperature2Click(Sender: TObject);
begin
 sendcmd(show_display_data+#2,2);
end;

procedure TForm1.DoCALibration1Click(Sender: TObject);
begin
 if qbox('Are you sure?') = idyes then begin
  sendcmd(show_display_data+#64,2);
 end;
end;

procedure TForm1.Setconfig1Click(Sender: TObject);
var a: array [1..100] of char;
begin
 fillchar(a,sizeof(a),0);
 sendcmd(read_eprom_byte8,10);
 if nrcv = 10 then begin
  move(rcv,a,8);
  sendcmd(read_eprom_byte8+#8,10);
  if nrcv = 10 then begin
   move(rcv,a[9],8);
   move(a,Form3.data,sizeof(Form3.data));
   if form3.showmodal = mrOK then begin
    move(form3.data,a,sizeof(form3.data));
    sendcmd(write_eprom_byte8+#0+a[1]+a[2]+a[3]+a[4]+a[5]+a[6]+a[7]+a[8],2);
    if nrcv = 2 then
    sendcmd(write_eprom_byte8+#8+a[9]+a[10]+a[11]+a[12]+a[13]+a[14]+a[15]+a[16],2);
    if nrcv <> 2 then ebox('Write error!');
   end;
  end;
 end;
end;


end.


