unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, math, crc8;

type

  TConfigData = record
   ZeroGasHi: byte;
   ZeroGasLo: byte;
   PreHeat: byte;
   LoBattHi: byte;
   LoBattLo: byte;
   ZeroLM19Hi: byte;
   ZeroLM19Lo: byte;
   BattDiv16: byte;
   DivLM19: byte;
   AutoCal: byte;
   Res1,Res2,Res3,Res4,Res5: byte;
   CRC: byte;
  end;

  TForm3 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    zgo: TEdit;
    ht: TEdit;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    lm19: TEdit;
    batdiv: TEdit;
    tempdiv: TEdit;
    crc: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label4: TLabel;
    lbo: TEdit;
    BitBtn3: TBitBtn;
    auto: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure editChange(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   data: TConfigData;
  end;

var
  Form3: TForm3;

implementation

{$R *.DFM}

function CalcCRC(d: TConfigData): byte;
var a: array [1..100] of byte;
    i: integer;
    crc: byte;
begin
 crc := 0;
 move(d,a,sizeof(d));
 for i := 1 to 15 do crc := crc8table[crc xor a[i]];
 result := crc;
end;

procedure TForm3.FormActivate(Sender: TObject);
begin
 zgo.Text := format('%d',[data.ZeroGasHi*256+data.ZeroGasLo]);
 lbo.Text := format('%d',[data.LoBattHi*256+data.LoBattLo]);
 ht.Text := inttostr(data.PreHeat);
 lm19.Text := inttostr(data.ZeroLM19Hi*256+data.ZeroLM19Lo);
 batdiv.Text := format('%d',[data.BattDiv16]);
 tempdiv.Text :=  format('%d',[data.DivLM19]);
 auto.Checked := data.AutoCal <> 0;
 crc.Text := inttostr(CalcCRC(data));
end;

procedure TForm3.BitBtn1Click(Sender: TObject);
begin
 editChange(Sender);
 modalresult := mrOK;
end;

procedure TForm3.editChange(Sender: TObject);
var d: TConfigData;
    v: integer;
begin
 v := strtointdef(trim(zgo.text),0);
 d.ZeroGasHi := hibyte(v);
 d.ZeroGasLo := lobyte(v);
 v := strtointdef(trim(lbo.text),0);
 d.LoBattHi := hibyte(v);
 d.LoBattLo := lobyte(v);
 d.PreHeat := strtointdef(trim(ht.text),0);
 v := strtointdef(trim(lm19.text),0);
 d.ZeroLM19Hi := hibyte(v);
 d.ZeroLM19Lo := lobyte(v);
 d.BattDiv16 := strtointdef(trim(batdiv.text),0);
 d.DivLM19 := strtointdef(trim(tempdiv.text),0);
 if auto.checked then d.AutoCal := 1 else d.AutoCal := 0;
 d.Res1 := 100; d.Res2 := 110; d.Res3 := 120;
 d.Res4 := 130; d.Res5 := 140;
 d.CRC := CalcCRC(d);
 move(d,data,sizeof(data));
 crc.Text := inttostr(d.crc);
end;

procedure TForm3.BitBtn3Click(Sender: TObject);
begin
 editChange(Sender);
end;

end.
